function ConfigLists(){
   /*
   Class to manage configuration lists window
   */
   
   this.lists=[];
   this.templateactive="";
   this.listspath='/etc/lliurex-guard-standalone/config/lists/';
   this.templatepath='/etc/lliurex-guard-standalone/config/';
   this.need_to_save=false;
	   
}

// Methods

ConfigLists.prototype.getTemplate= function getTemplate(selected, templates){
   /*
    * get template config from selected template
    **/ 
   
   for (i in templates){
	  console.log(templates[i]);
	  if (templates[i].template==selected)
	  return templates[i];
	}
   return null;
}


ConfigLists.prototype.getLists = function getLists(){
   /*
   * Read all filename lists in config lists. Files will be read later, when clic on edit
   */
   
    var self=this;
	var fs = require('fs');
	var files = fs.readdirSync(self.listspath);
	for (var i in files) {
	  try{
		 if(fs.statSync(self.listspath+files[i]).isFile()) {
			   	itemlist={file: files[i]};
		 self.lists.push(itemlist);
		 }	 
	  	} catch (err){
			console.log(err);
			continue;
		}
	}
	return self.lists;
}

ConfigLists.prototype.removeList = function removeList(list){
   var self=this;
   
   var id=($(list).attr("id"));
   
   var r = confirm(i18n.gettext("confirm.remove"));
   if (r == true) {
	  
   // Delete File via N4D
	  $.xmlrpc({
		 url: 'https://'+localStorage.server+':9779',
		 methodName: 'remove_list_file',
		 params: [[localStorage.username, localStorage.password], "N4dGuard", id],
		 success: function(response,status,jqXHR){
			if (response[0]!=true) {
			   alert("Error: "+response[0]);
			} else {
			   // Removint list from GUI
			   $(list).parent().remove();
			}
		 	console.log(response[0]);
		
			
		},
		error: function(jqXHR, status, error) {
			alert("Status: "+status+"\nError: N4D server is down "+error);
		}
	  })
   	
	
	
   }
}



ConfigLists.prototype.loadList = function loadList(list, is_new){
   /*
   * Loads a new window to edit list. list is a tuple (filename, list)
   */
   var self=this;
   // Set is_new if not defines as false,
   // to know if is a new list or we are editing an existent
   if (typeof(is_new)==undefined) is_new=false;
   
   var gui = require('nw.gui');
   localStorage.edit_list=list;
   // Set flag to save if file is new
   localStorage.force_initial_save=is_new;
			
   var new_win = gui.Window.open('edit_list.html', {
   /*
   New window for list
   */		   
	  toolbar:false,
	  position: 'center',
	  icon: "/usr/share/pixmaps/lliurex-guard-standalone.png",
	  width: 400,
	  height: 500,
	  frame:true,
	  'single-instance':true,
	  title: i18n.gettext("configlist.EditList"),
	  focus: true 
   });

   new_win.on('loaded', function() {
   // Freezing main window until list window is closed
			   $("#modal_list").removeClass("work");
			   $("#modal_list").addClass("freezed"); 		   
			});
			
   new_win.on('closed', function() {
		  // Unfreezing when list window is closed
		  new_win.close(true);
		  $("#modal_list").removeClass("freezed");
		  $("#modal_list").addClass("work");
		  new_win=null;
			   
   });
						
			
			/* Listen to main window's close event */
			
		 gui.Window.get().on('close', function() {
			// Hide the window to give user the feeling of closing immediately
			this.hide();
			
			// If the new window is still open then close it.
			if (new_win != null)
			   new_win.close();
			
			// After closing the new window, close the main window.
			this.close(true);
			/*  END: Listen to main window's close event */
			
		 });

}

ConfigLists.prototype.SaveTemplate = function SaveTemplate(template){
   // N4d call to save template file
   var self=this;
   
	$.xmlrpc({
		 url: 'https://'+localStorage.server+':9779',
		 methodName: 'save_template',
		 params: [[localStorage.username, localStorage.password], "N4dGuard", template ],
		 success: function(response,status,jqXHR){
			if (response[0]!=true) {
			   alert("Error: "+response[0]);
			} else {
			   // if saved successfull, read the new config
			   console.log(self.lists);
			   
			   // Print save message
			   $("#infotext").html(i18n.gettext("file.saved"));
			   $("#infotext").addClass("shown");
			   
			   // Clean need to save
			   self.need_to_save=false;
			}
		 	console.log(response[0]);
		
		},
		error: function(jqXHR, status, error) {
			alert("Status: "+status+"\nError: N4D server is down "+error);
		}
	  })
   
   
}

ConfigLists.prototype.CreateItemList = function CreateItemList(itemToAdd, checked){
   
   // Creates an item list with a checkbox to represent lists
   self=this;
   
   var divitem=$(document.createElement("div")).addClass("checkbox").addClass("form-control");
   var item=$(document.createElement("input")).addClass().attr("type", "checkbox").attr("name",itemToAdd.file);
   if (checked) $(item).prop('checked',true);	  
	  
	  var label=$(document.createElement("label"));
	  var labeltext=itemToAdd.file;
	  var editbt=$(document.createElement("div")).addClass("edit_list").attr("id", labeltext);
	  var deletebt=$(document.createElement("div")).addClass("remove_list").attr("id", labeltext);
	  
	  $(editbt).bind("click", function(event){
		 // Getting id from list
		 list=($(event.target).attr("id"));
		 
		 // Check size for file
	  
		 var stats = fs.statSync(self.listspath+list)
		 var fileSizeInBytes = stats["size"];
		 open_with_editor=false;
		 
		 // If file is too big, open with system default editor
		 if (fileSizeInBytes>1000000) {
			open_with_editor=confirm(i18n.gettext("file.too.large"));
		 }
			
		 if (open_with_editor) {
			
			// Set window as not editable
			$("#modal_list").removeClass("work");
			$("#modal_list").addClass("freezed");
			textUnblock=document.createElement("div");
			$(textUnblock).addClass("textunblock").html(i18n.gettext("Unblock.txt"));
			// Create button for remove freeze
			btUnblock=document.createElement("button");
			$(btUnblock).attr("id", "btnHideEdit").addClass("btn btn-success btcenter").html(i18n.gettext("Unblock.Finish"));
			$(modal_list).append(textUnblock);
			$(modal_list).append(btUnblock);
			$(btUnblock).bind("click", function(){
			   $("#modal_list").empty();
			   $("#modal_list").removeClass("freezed");
			   $("#modal_list").addClass("work");
			   
			   });
			
			
			
			// Open Editor
						
			$.xmlrpc({
				  url: 'https://'+localStorage.server+':9779',
				  methodName: 'execute',
				  params: [[localStorage.username, localStorage.password], "GuiLauncherManager", "", localStorage.username, "xdg-open "+self.listspath+list],
				  success: function(response,status,jqXHR){
					//alert(response[0]["status"]+"\n"+response[0]["msg"]); 
				 },
				 error: function(jqXHR, status, error) {
					 alert("Status: "+status+"\nError: N4D server is down "+error);
				 }
			   })
			
			
		 } else {
	  		  // Reading list
			 
			itemlist={file: list, filepath: self.listspath+list};
		 
			self.loadList(JSON.stringify(itemlist));
		 }
	  });
	  
	  $(deletebt).bind("click", function(event){
		 // Getting id from list
		 //list=($(event.target).attr("id"));
		 list=($(event.target));
		 //alert(list);
		 self.removeList(list);
	  });
	  
	  
	  
	  $(label).append(item);
	  $(label).append(labeltext);
	  $(divitem).append(label);
	  $(divitem).append(deletebt);
	  $(divitem).append(editbt);
	  
   
	  return divitem;
      
}

ConfigLists.prototype.ShowGui= function ShowGui(template){
   var self=this;
   // Clean any old content...
   $("#list_content").empty();
   // blacklist -> file list
   // desc -> Description
   // tclass
   // default_policy
   // whitelist
   
   // Set initial value for policy selector
   $('#policy_selector').val(template.default_policy).trigger('change');
   
   // Set lists in function of selected value   
   if (template.default_policy=="allow") list_to_show=template.blacklist;
   else list_to_show=template.whitelist;
   
	  // Read all lists
   
   for (i in self.lists) {
	  // check if list is activated in template
	  var checked=false;  
	  
	  for (j in list_to_show){
		 
		 if (self.lists[i].file==list_to_show[j]) {
			checked=true;
			break;
		 }
	  }
	  
	  // Create item for editing list
	  divitem=self.CreateItemList(self.lists[i], checked);
	  $("#list_content").append(divitem);
	  
	  
	  
	  $( "input[type='checkbox']" ).bind("click", function(){
		 // if there is any change, set need_to_save_flag
		 self.need_to_save=true;
		 });
	  
   }
   
   // Adding button for a new list
   var divitem=$(document.createElement("div")).addClass("form-control").addClass("btn-success").addClass("new_list").html("New List");
   var addicon=$(document.createElement("div")).addClass("new_list_img");
   $(divitem).append(addicon);
   $("#list_content").append(divitem);
   
   $(divitem).bind("click", function(event){
	  var listname = prompt(i18n.gettext("insert.filename"));

	  if (listname!= null && listname!="") {
		 //itemlist={file: listname, list: []};
		 
		 itemlist={file: listname, filepath: self.listspath+listname};
		 
		 newitem=self.CreateItemList(itemlist, true);
		 
		 $(event.target).before(newitem);
		 
		 //$("#list_content").append(newitem);
		 
		 
		 //$("#list_content").before(newitem, $(this));
		 
		 
		 ret=self.loadList(JSON.stringify(itemlist), true);
		 
		 //ConfigLists.prototype.CreateItemList = function CreateItemList(itemToAdd, checked){

		 }
	  
	  
	  });
   
   
}

ConfigLists.prototype.bindEventHandlers = function bindEventHandlers(){
   var self=this;
   $("#policy_selector").change(function(){
	  /*
	  When change selected policy we have to update gui
	  */
	  	  
	   $( "select#policy_selector option:selected" ).each(function() {
		 selected = $( this ).val();
		 if (selected=="deny") {
			//help_text=i18n("");
			help_text=i18n.gettext("help.text.deny");
			list_name=i18n.gettext("White.List");
		 } else{
			help_text=i18n.gettext("help.text.allow");
			list_name=i18n.gettext("Black.List");
		 }
		 
		 $("#help_text").empty().append(help_text);
		 $("#list_name").empty().append(list_name);
		 
	  });
	  $("input:checkbox").removeAttr("checked");  
   });
   
   
   $("#btsavetemplate").bind("click",function(){
	  /*
	  Saves template on /etc/lliuerex-guard-standalone/config in json format
	  Example:	  
	  {
		 "template":"allow_all",
	      "desc":"Allow all",
		 "class":"default",
	      "default_policy": "allow",
		 "blacklist":[
			"prensa.list",
	  		"games.list"
		 ]
	  }
	  */
	  
	  // Preparing json
	  templateitem={}
	  templateitem.template=self.templateactive.template;
	  templateitem.desc=self.templateactive.desc;
	  templateitem.tclass=self.templateactive.tclass;
	  templateitem.default_policy=$("#policy_selector").val();
	  
	  filelist=[];
	  // adding selected files to json
	  $( "input[type='checkbox']" ).each(function( index ) {
		 if ($(this).is(":checked"))
		     filelist.push($( this ).attr("name"));
		 
		 //console.log( index + ": " + $( this ).attr("name")+ " is "+($(this).is(":checked")));
	  });
	  
	  if (templateitem.default_policy=="allow") templateitem.blacklist=filelist;
	  else templateitem.whitelist=filelist;
	  
	  // Saving templateitem
	  self.SaveTemplate(templateitem);
	  
	  });
   $("#btcanceltemplate").bind("click",function(){
	   	   var gui = require('nw.gui');
		   var win = gui.Window.get();
		   if (self.need_to_save) {
				var r = confirm(i18n.gettext("close.no.saving"));
			    if (r == true) win.close();
			
		   } else win.close();
		   
	  });
   
   $("#btremovetemplate").bind("click",function(){
	  if (self.templateactive.tclass==="default") // we can't delete default demplates
		 alert(i18n.gettext("can-not-remove-default-template"));
		 else{
			// Confirm template delete
			var r = confirm(i18n.gettext("Really-delete-template"));
			if (r == true) {
			   
			   // Delete templave via n4d
			   $.xmlrpc({
				  url: 'https://'+localStorage.server+':9779',
				  methodName: 'remove_template',
				  params: [[localStorage.username, localStorage.password], "N4dGuard", self.templateactive.template],
				  success: function(response,status,jqXHR){
					 if (response[0]!=true) {
						alert("Error: "+response[0]);
					 } else {
						var gui = require('nw.gui');
						var win = gui.Window.get();
						alert(i18n.gettext("template-has-been-deleted"));
						win.close();
					 }
					 
				 
					 
				 },
				 error: function(jqXHR, status, error) {
					 alert("Status: "+status+"\nError: N4D server is down "+error);
				 }
			   })
			   
			   
			   
			}
	  
		 } // else
	  
   
	  });
   
   
   
   
}

$(document).ready(function() {
   // When config window is loaded, take template_files and selected template from localStorage
   templates=JSON.parse(localStorage.getItem("template_files"));
   selected=localStorage.getItem("selected_template");
   
   
   // Populate GUI with list configuration
   MyGUI=new ConfigLists();
   $("#modal_list").addClass("work");
   
   MyGUI.getLists();
   
   template=MyGUI.getTemplate(selected, templates);
   //alert(JSON.stringify(templates));
   MyGUI.templateactive=template;
   
   MyGUI.bindEventHandlers();
   
   MyGUI.ShowGui(template);
    
})