
function LliureXGuardStandalone(){
   /*
   Class LliureXGuardStandalone
   */
   this.template_files=this.getFiles();
   this.running_template=this.getRunningTemplate();
   this.populateGui();
   
}

// Methods

LliureXGuardStandalone.prototype.bindEventHandlers = function bindEventHandlers(){
   var self=this;
   
	$("#ApplyBt").bind('click', function( event ){
	  /*
	  Apply a template to squid3 config files
	  */
	  var r = confirm(i18n.gettext("sure.to.apply.template.confirm"));
	  if (r == true) {
		 $("#modal").removeClass("work");
		 $("#modal").addClass("freezed"); 
		 
		 var templatename=$("#template_selector option:selected").attr("value");
		 $.xmlrpc({
				  url: 'https://'+localStorage.server+':9779',
				  methodName: 'apply_template',
				  params: [[localStorage.username, localStorage.password], "N4dGuard", templatename],
				  success: function(response,status,jqXHR){
					 if (response[0]!=true) {
						alert("Error: "+response[0]);
						console.log(response[0]);
					 } else {
						$("#modal").removeClass("freezed");
						$("#modal").addClass("work"); 
						alert(i18n.gettext("template.applied"));
					 }
			}
		 }); // XMLRPC
	    } // if r==true
	  }); // ApplyBt
	
	
	$("#ConfigBt").bind('click', function( event ){
	  /*
	  Configure template event: Edits lists to enable/disable and configure them
	  */
			var gui = require('nw.gui');
			
			localStorage.setItem("template_files", JSON.stringify(self.template_files));
			localStorage.setItem("selected_template", $("#template_selector option:selected").attr("value"));
			
			var new_win = gui.Window.open('configure_list.html', {
			   /*
			   New window for configure lists
			   */
			   
			   toolbar:false,
			   position: 'center',
			   icon: "/usr/share/pixmaps/lliurex-guard-standalone.png",
			   width: 400,
			   height: 550,
			   frame:true,
	  			'single-instance':true,
			   title: i18n.gettext("Edit.Template"),
			   focus: true 
			
			});
			
			
			
			new_win.on('loaded', function() {
			   // Freezing main window until list window is closed
			   $("#modal").removeClass("work");
			   $("#modal").addClass("freezed");   
			   
			   
			});
			
			new_win.on('closed', function() {
			   // Unfreezing when list window is closed
			   
			   new_win.close(true);
			   $("#modal").removeClass("freezed");
			   $("#modal").addClass("work");
			   new_win=null;
			   
			   // Refresh files and gui
			   self.template_files=self.getFiles();
			   self.populateGui();
			   
			});
						
			
			/* Listen to main window's close event */
			gui.Window.get().on('close', function() {
			// Hide the window to give user the feeling of closing immediately
			this.hide();
			
			// If the new window is still open then close it.
			if (new_win != null)
			new_win.close();
			
			// After closing the new window, close the main window.
			this.close(true);
			/*  END: Listen to main window's close event */
			
			
		 });
			
					
		});

} // End Bind Event Handlers

LliureXGuardStandalone.prototype.getRunningTemplate = function getRunningTemplate(){
 /*Get all config files from /etc/lliurex-guard-standalone/config/running_template*/
   var self=this;
   var filepath='/etc/lliurex-guard-standalone/config/running_template';
   var fs = require('fs');
   
   var template="";
   
   	 if(fs.statSync(filepath).isFile()) {
		 jsonContent=JSON.parse(fs.readFileSync(filepath).toString());
			template=jsonContent.running_template;
		 }
	return template;
}


LliureXGuardStandalone.prototype.getFiles = function getFiles(){
   /*
   Get all config files from /etc/lliurex-guard-standalone/config/
   
   Config file structure (JSON):
	  template: template name (filename)
	  desc: Description
	  tclass: is a default list or user-defined
	  default_policy: allow or deny by default
	  blacklist: disabled domains for allow policy default
	  whitelist: enabled domains for deny policy default
   */
   
   var self=this;
   var templatepath='/etc/lliurex-guard-standalone/config/';
   var fs = require('fs');
   var files = fs.readdirSync(templatepath);
   var filelist=[];
   for (var i in files) {
	  try{
		 if(fs.statSync(templatepath+files[i]).isFile())
		 {
				jsonContent=JSON.parse((fs.readFileSync(templatepath+files[i])).toString());
			    file={template:jsonContent.template,
					 desc:jsonContent.desc,
					 tclass:jsonContent.tclass,
					 default_policy:jsonContent.default_policy,
					 blacklist:jsonContent.blacklist,
					 whitelist:jsonContent.whitelist}
	  			filelist.push(file);
			}
	  	} catch (err){
			console.log(err);
			continue;
		}
	}
	return filelist;
}



LliureXGuardStandalone.prototype.CreateNewTemplate = function CreateNewTemplate(description){
   var self=this;
   
   // sanitize fiename
   templatename=description.replace(/\W/g, '');
   
   
   // Preparing json
   templateitem={}
   templateitem.template=templatename;
   templateitem.desc=description;
   templateitem.tclass="custom";
   templateitem.default_policy="allow";
   templateitem.blacklist=[];
	
   
   
   
   $.xmlrpc({
		 url: 'https://'+localStorage.server+':9779',
		 methodName: 'save_template',
		 params: [[localStorage.username, localStorage.password], "N4dGuard", templateitem ],
		 success: function(response,status,jqXHR){
			if (response[0]!=true) {
			   alert("Error: "+response[0]);
			} else {
			   // if saved successfull, read the new config
			   console.log(self.lists);
			   
			   var option=$(document.createElement("option")).attr("value", templatename).html(description);
			   $("#template_selector").append(option);
			   
			   // Read template_files with new file
			   self.template_files=self.getFiles();
			   //Set template selector to this value
			   $("#template_selector").val(templatename);
			   
			}
		 	console.log(response[0]);
		
		},
		error: function(jqXHR, status, error) {
			alert("Status: "+status+"\nError: N4D server is down "+error);
		}
		
   });
	  
   
}

LliureXGuardStandalone.prototype.populateGui = function populateGui(){
   /*
   Prepare GUI when files are loaded
   */
   var self=this;
   $("#template_selector").empty();
   for (i in self.template_files) {
	  var option=$(document.createElement("option")).attr("value", self.template_files[i].template).html(self.template_files[i].desc);
	  if (self.running_template==self.template_files[i].template)
		 $(option).attr("selected", "selected");
		 if (typeof($(option).attr("value"))!="undefined")
			$("#template_selector").append(option);
		 
   }
   
   var option=$(document.createElement("option")).attr("value", "new").html(i18n.gettext("create-new-template"));
   $("#template_selector").append(option);
   $("#template_selector").bind("change", function(){
	  // If select new template, ask for name
	  if($("#template_selector").val()=="new"){
		 var templatename = prompt(i18n.gettext("insert.desc.for.template"));
	  if (templatename!= null && templatename!="") {
		 // Create an empty template
			self.CreateNewTemplate(templatename);
		 } else {
			// if cancel adding new item, select first template
			$("#template_selector option")[0].selected = true;
			}
				 
	  } // If select new
	  
     
	  }); // End for capture change event
}

$(document).ready(function() {
   
   //Login GUI
   var llxguardLogin=new LliureXGuardStandaloneLogin();
   
   // Main UI
   var llxguard=new LliureXGuardStandalone();
   $("#modal").addClass("work");
	
   // Binding event handlers
   llxguardLogin.bindEventHandlers();
   llxguard.bindEventHandlers();
	
    
})
